const config = require("./config.json")
const DMC = require('dmc.js')
const { user, new_name } = require('./utils');
const XLSX = require("xlsx");
const fs = require("fs");
let account = "";
let private_key = "";
let amount = "";

console.notice("------- 批量创建账号工具 -------\n");
while (true) {
    account = console.readLine("请输入创建者用户名:\n");
    if (!account) continue;
    private_key = console.getpass("请输入私钥:\n")
    if (!private_key) continue;
    amount = console.readLine("请输入需要创建的账户数量:\n")
    if (!amount) continue;
    if (!/^[0-9]+.?[0-9]*/.test(amount)) { console.error("请输入有效数字"); process.exit(1) }
    break;
}

let yes = console.readLine(`\n-------------------------------------\n
目前环境为 ${config.httpEndpoint}\n
对应的chainId为 ${config.chainId}\n
请确保环境正确\n
将使用 ${account} 的权限创建 ${amount} 个账号\n\n
请确认 (Y/N)? \n
-------------------------------------\n`)


let dmc = DMC({
    chainId: config.chainId,
    keyProvider: private_key,
    httpEndpoint: config.httpEndpoint,
    logger: {
        log: null,
        error: null
    }
});

let success = [];
let now = 0;
if (['Y', 'y'].indexOf(yes) !== -1) {
    for (var i = 0; i < amount; ++i) {
        try {
            let prikey = DMC.ecc.randomKey_sync(undefined, { secureEnv: true });
            let pubkey = DMC.ecc.privateToPublic(prikey);
            let name = new_name();
            console.warn(`------正在创建${name} ------`);
            user(dmc, account, name, pubkey)
            success.push({
                account: name,
                prikey: prikey,
                pubkey: pubkey,
            })
            now = i + 1;
        } catch (e) {
            console.error('---- e ----', e);
            break;
        }
    }
    if (success.length > 0) {
        let ws = XLSX.utils.json_to_sheet(success);
        const wk = XLSX.utils.book_new();
        XLSX.utils.book_append_sheet(wk, ws, "Datas")
        XLSX.writeFileXLSX(wk, "./account_" + new Date().getTime() + ".xlsx")
        console.warn(`----完成${now}个账号的创建----, 如下: \n`, success);
    }
} else {
    process.exit(1);
}
