## 批量创建账号脚本

### 文件目录

 ```bash
 .
 ├── config.json			配置文件
 ├── index.js				创建账号脚本			
 └── utils.js				工具类
 ```

### 配置详情

```json
{
    "chainId": "4d1fb981dd562d2827447dafa89645622bdcd4e29185d60eeb45539f25d2d85d",
    "newAccountConfig": {
        "cpu": "0.1000 DMC",				// 每个账号抵押的 cpu
        "net": "0.1000 DMC",				// 每个账号抵押的 net
        "ram": "0.2000 DMC"					// 每个账号购买的 ram
    },
    "httpEndpoint": "http://18.188.82.206:15795"    // 正式网 httpEndpoint
}
```

### 使用说明

#### 修改配置文件

按需改配置文件里的 `chainId` 和 `httpEndpoint`

#### 安装依赖

```
dmc --install
```

#### 步骤

```
dmc index.js

>
请输入创建者用户名:

请输入私钥:

请输入需要创建的账户数量:

-------------------------------------

将使用 x 的权限创建 x 个账号

请确认 (Y/N)?

-------------------------------------
```

**注意：输入私钥的时候不会显示，正常输入即可**

#### 输出结果

```
---- 完成10个账号的创建 ----, 如下:
 [
  {
    "account": "5ynorb1dqyw3",
    "prikey": "5JeCLYB9PnvDMZD8DYPzcnLnEvsPvka4ewPAPSpRjwUkcbcuA38",
    "pubkey": "DM5qZRTNRUsAkMxvwq5D46s26k361d8tSeePM2SbmNVRD5gpYqyd"
  },
  ...
  {
    "account": "etpuvvd4hyt4",
    "prikey": "5KPTHi7HcvchKboJbfJUSYXW4MdjBeGk1onYmUP8oPHMiDU8aPE",
    "pubkey": "DM7ZDDe8ULA9Eh85RD7i5HCUALMUGXRH4A7Zp7Wemg5pr6aGu2yN"
  }
]
```

同时会输出对应 xlsx 文件。
