let config = require("./config.json")

function new_name() {
    const base32_chars = 'abcdefghijklmnopqrstuvwxyz12345';
    var name = "";
    for (var i = 0; i < 12; i++)
        name += base32_chars.substr(Math.floor(Math.random() * 31), 1);
    return name;
}

function user(dmc, creator, name, pubkey) {
    dmc.transact_sync({
        actions: [
            {
                account: 'dmc',
                name: 'newaccount',
                authorization: [{
                    actor: creator,
                    permission: 'active',
                }],
                data: {
                    creator: creator,
                    name: name,
                    owner: {
                        threshold: 1,
                        keys: [{
                            key: pubkey,
                            weight: 1
                        }],
                        accounts: [],
                        waits: []
                    },
                    active: {
                        threshold: 1,
                        keys: [{
                            key: pubkey,
                            weight: 1
                        }],
                        accounts: [],
                        waits: []
                    },
                }
            }, {
                account: 'dmc',
                name: 'buyram',
                authorization: [{
                    actor: creator,
                    permission: 'active',
                }],
                data: {
                    payer: creator,
                    receiver: name,
                    quant: config.newAccountConfig.ram
                },
            },
            {
                account: 'dmc',
                name: 'delegatebw',
                authorization: [{
                    actor: creator,
                    permission: 'active',
                }],
                data: {
                    from: creator,
                    receiver: name,
                    stake_net_quantity: config.newAccountConfig.net,
                    stake_cpu_quantity: config.newAccountConfig.cpu,
                    transfer: false
                },
            }]
    }, {
        blocksBehind: 3,
        expireSeconds: 30,
    });
    return name;
}

module.exports = {
    user: user,
    new_name: new_name
}