let DMC = require('dmc.js');
let config = require("./config.json")

let account = "";
let private_key = "";

console.notice("------- 提交多签工具 -------\n");
while (true) {
    account = console.readLine("请输入用户名:\n");
    if (!account) continue;
    private_key = console.getpass("请输入私钥:\n")
    if (!private_key) continue;
    break;
}

//初始化客户端
let dmc = DMC({
    chainId: config.chainId,
    keyProvider: private_key,
    httpEndpoint: config.httpEndpoint,
    logger: {
        log: null,
        error: null
    }
});

let requested = []
config.accounts.forEach(e => {
    requested.push({
        actor: e,
        permission: "active"
    })
})

let contractName = config.propose.contractName;
let actionName = config.propose.actionName;
let actions = [{
    'account': contractName,
    'name': actionName,
    'authorization': [{
        "actor": account,
        "permission": "active"
    }],
    'data': config.propose.execData
}]
let serializeActions = dmc.serializeActions_sync(actions);


let yes = console.readLine(`\n-------------------------------------\n
此方法将以 ${account} 用户的身份提交多签事务，需要同意的用户如下:\n
${JSON.stringify(config.accounts, null, 4)}\n
执行 ${contractName} 合约内的 ${actionName} 方法，\n
事务内容如下:\n
${JSON.stringify(config.propose.execData, null, 4)}\n
过期时间为: ${config.propose.expiration}\n
 \n请确认 (Y/N)? \n-------------------------------------\n`)

if (['Y', 'y'].indexOf(yes) !== -1) {
    dmc.transact_sync({
        actions: [{
            account: 'dmc.msig',
            name: 'propose',
            authorization: [
                {
                    actor: account,
                    permission: 'active'
                },
            ],
            data: {
                "proposer": account,
                "proposal_name": config.propose.proposalName,
                "requested": requested,
                "trx": {
                    "expiration": config.propose.expiration,
                    "ref_block_num": 0,
                    "ref_block_prefix": 0,
                    "max_net_usage_words": 0,
                    "max_cpu_usage_ms": 0,
                    "delay_sec": 0,
                    "context_free_actions": [],
                    "actions": serializeActions,
                    "transaction_extensions": []
                }
            }
        }]
    }, {
        blocksBehind: 3,
        expireSeconds: 30,
    });
}
console.log("\n执行成功")