## 提交多签提案脚本

**以下所有操作推荐在ubuntu18.04的环境下运行**

### 文件目录

```
.
├── README.md
├── config.json						配置文件
└── proposal.js						提交多签脚本
```

### 配置详情

```json
{
    "chainId": "4d1fb981dd562d2827447dafa89645622bdcd4e29185d60eeb45539f25d2d85d",
    "httpEndpoint": "http://18.188.82.206:15795",
    "accounts": [								// 需要同意的用户
        "wvenzvxvoox5",
        "3ilviqxcflvt",
        "jxpfmv4hakh4"
    ],
    "propose": {
        "proposalName": "extransfer",			// 提案名
        "contractName": "dmc.token",			// 执行合约名
        "actionName": "extransfer",				// 执行的合约方法
        "execData": {							// 执行方法的详细数据
            "from": "datamall",
            "to": "dmctestnet2",
            "quantity": {
                "quantity": "1.0000 DMC",
                "contract": "datamall"
            },
            "memo": "memo"
        },
        "expiration": "2024-01-01T00:00:00"		// 该提案的过期时间
    }
}
```

### 使用说明

#### 安装依赖

```bash
$ sh dmc_installer.sh
> This program will install dmc into /usr/local/bin.

$ dmc
Welcome to DMCHAIN Vxxxxxx. Based on fibjs 0.36.0-dev.
Type ".help" for more information.
>

$ dmc --install
```

-----

**以下操作请根据实际情况修改配置文件**

#### 执行多签提案

```
dmc proposal.js
> 
请输入用户名:
ua3ql333tzig
请输入私钥:

-------------------------------------

此方法将以 datamall 用户的身份提交多签事务，需要同意的用户如下:

[
    "wvenzvxvoox5",
    "3ilviqxcflvt",
    "jxpfmv4hakh4"
]

执行 dmc.token 合约内的 extransfer 方法，

事务内容如下:

{
    "from": "datamall",
    "to": "dmctestnet2",
    "quantity": {
        "quantity": "1.0000 DMC",
        "contract": "datamall"
    },
    "memo": "memo"
}

过期时间为: 2024-01-01T00:00:00

 
请确认 (Y/N)? 
-------------------------------------
```

说明：

1. 用户名为提交该多签提案的用户，而不是转账的用户

2. `execData`中的数据以 `contractName`+`actionName` 对应的 abi 为准，常见操作见操作指南。

3. **提案要求`execData`中需要权限的用户已经分配对应权限给`accounts`，否则报错**

4. 多签执行成功并不意味着`execData`的事务执行成功

5. **私钥不会显示在屏幕上，确保输入一次以后继续执行即可**
