let DMC = require('dmc.js');
let config = require("./config.json")

let account = "";
let private_key = "";
let proposer = "";
let proposal_name = "";
console.notice("------- 同意多签脚本 -------\n");
while (true) {
    account = console.readLine("请输入用户名:\n");
    if (!account) continue;
    private_key = console.getpass("请输入私钥:\n")
    if (!private_key) continue;
    proposer = console.readLine("请输入提案人:\n");
    if (!proposer) continue;
    proposal_name = console.readLine("请输入提案名称:\n");
    if (!proposal_name) continue;
    break;
}

//初始化客户端
let dmc = DMC({
    chainId: config.chainId,
    keyProvider: private_key,
    httpEndpoint: config.httpEndpoint,
    logger: {
        log: null,
        error: null
    }
});

dmc.transact_sync({
    actions: [{
        account: 'dmc.msig',
        name: 'approve',
        authorization: [
            {
                actor: account,
                permission: 'active'
            },
        ],
        data: {
            "proposer": proposer,
            "proposal_name": proposal_name,
            "level": {
                "actor": account,
                "permission": "active"
            }
        }
    }]
}, {
    blocksBehind: 3,
    expireSeconds: 30,
});

console.log("--------- 执行完毕 -----------")