## 多签脚本

**以下所有操作推荐在ubuntu18.04的环境下运行**

### 文件目录

```
.
├── README.md
├── approve.js						同意提案
├── config.json						配置文件
└── proposal.js						多签脚本
```

### 配置详情

```json
{
    "chainId": "4d1fb981dd562d2827447dafa89645622bdcd4e29185d60eeb45539f25d2d85d",
    "httpEndpoint": "http://18.188.82.206:15795",
    "accounts": [						// 需要同意的账户
        "wvenzvxvoox5",
        "3ilviqxcflvt",
        "jxpfmv4hakh4"
    ],
    "propose": {
        "proposalName": "extransfer",		// 提案名
        "from": "cuboa2wn2aqa",				
        "to": "jxpfmv4hakh4",
        "quantity": {						// 金额
            "quantity": "1.0000 DMC",
            "contract": "datamall"
        },
        "memo": "good luck"
    }
}
```

### 使用说明

#### 安装依赖

```bash
$ sh dmc_installer.sh
> This program will install dmc into /usr/local/bin.

$ dmc
Welcome to DMCHAIN Vxxxxxx. Based on fibjs 0.36.0-dev.
Type ".help" for more information.
>

$ dmc --install
```

-----

**以下操作请根据实际情况修改配置文件**

#### 执行多签提案

```
dmc proposal.js
> 
请输入用户名:
ua3ql333tzig
请输入私钥:

```

说明：

1. 用户名为提交该多签提案的用户，而不是转账的用户

2. 本脚本只支持转账操作，从`from`转账到`to`账户，如果转账 `PST`，则`quantity`修改为类似如下：

   ```
   "quantity": {						
   	"quantity": "1 PST",
   	"contract": "datamall"
   }
   ```

3. **私钥不会显示在屏幕上，确保输入一次以后继续执行即可**

```
1. propose				# 提交多签提案
2. list approvals		# 展示已经提交的多签提案
3. exec propose			# 执行多签提案，需要所有人同意才可以执行
4. cancel propose		# 取消多签提案
```

#### 同意多签提案

```
dmc proposal.js
> 
------- 同意多签脚本 -------

请输入用户名:
jxpfmv4hakh4
请输入私钥:

请输入提案人:
ua3ql333tzig
请输入提案名称:
extransfer
--------- 执行完毕 -----------
```

此时输入需要同意多签提案的用户，本例为`wvenzvxvoox5 \ 3ilviqxcflvt \ jxpfmv4hakh4`