let DMC = require('dmc.js');
let config = require("./config.json")
const configToString = {
    "bmrate": "全网基准 m 值",
    "challinter": "存储挑战的响应时间间隔"
}

let private_key = "";
function getPrivateKey() {
    while (true) {
        private_key = console.getpass("请输入 dmcconfigura 的私钥:\n")
        if (!private_key) continue;
        break;
    }
}

let data = {
    'key': "",
    'value': "",
}
function chooseConfig() {
    console.log(
        `
1. 修改全网基准 m 值 (bmrate)
2. 修改存储挑战的响应时间间隔 (challinter)
`
    )
    var choose = Number(console.readLine("choice:"));
    switch (choose) {
        case 1:
            data.key = "bmrate";
            data.value = console.readLine("请输入新的基准 m 值, 例如 4 :\n");
            data.value = parseInt(data.value);
            data.value *= 100;
            break;
        case 2:
            data.key = "challinter";
            data.value = console.readLine("请输入新的存储挑战的响应时间间隔(天), 例如 1 :\n");
            data.value = parseInt(data.value);
            data.value *= 86400;
            break;
        default:
            console.log("输入错误");
            chooseConfig();
    }
}

getPrivateKey();
chooseConfig();

//初始化客户端
let dmc = DMC({
    chainId: config.chainId,
    keyProvider: private_key,
    httpEndpoint: config.httpEndpoint,
    logger: {
        log: null,
        error: null
    }
});


let yes = console.readLine(`\n-------------------------------------\n
此方法将以 dmcconfigura 账户的身份修改配置\n
${configToString[data.key]}\n
请确认 (Y/N)? \n-------------------------------------\n`)

if (['Y', 'y'].indexOf(yes) !== -1) {
    dmc.transact_sync({
        actions: [{
            'account': 'dmc.token',
            'name': 'setdmcconfig',
            'authorization': [{
                "actor": "dmcconfigura",
                "permission": "active"
            }],
            'data': {
                'key': data.key,
                'value': data.value,
            }
        }]
    }, {
        blocksBehind: 3,
        expireSeconds: 30,
    });
}

console.log("\n执行成功");