## 修改权限

**以下所有操作推荐在ubuntu18.04的环境下运行**

### 文件目录

```
.
├── config.json			配置文件	
├── package.json		依赖安装文件
├── readme.md			说明文件
├── recover_active.js	恢复 active 权限脚本
├── update_active.js	更新 active 权限脚本
└── update_owner.js		更新 owner 权限脚本
```

### 配置详情

```json
{
    "chainId": "4d1fb981dd562d2827447dafa89645622bdcd4e29185d60eeb45539f25d2d85d",
    "httpEndpoint": "http://18.188.82.206:15795",
    "accounts": [	 // active 分配给以下三个账户
        "wvenzvxvoox5",
        "3ilviqxcflvt",
        "jxpfmv4hakh4"
    ],
    "keys": [		// owner 分配给自己和以下两个公钥（私钥）
        "DM8UwpmVagnW9ziTDYLUCcye93wM1nGLDUndonkgdquK4BMtUF7v",
        "DM8R3JsneRiBYsGxKcFx4rYp73xYsfE2s9AN8ZyErujAL8owS9Kk"
    ]
}
```

### 使用说明

#### 安装依赖

```bash
$ sh dmc_installer.sh
> This program will install dmc into /usr/local/bin.

$ dmc
Welcome to DMCHAIN xx. Based on fibjs 0.36.0-dev.
Type ".help" for more information.
>

$ dmc --install
```

-----

**以下操作请根据实际情况修改配置文件**

#### 修改用户权限

**私钥均不会打印在屏幕上，确保粘贴无误，继续操作即可**

```
dmc updateauth_active.js
> 
请输入用户名:
xxxxx
请输入私钥:

```
此时输入需要被修改权限人的用户名和私钥，该用户的`active`权限将被分配给配置文件中的`accounts`

```
dmc updateauth_owner.js
> 
请输入用户名:
xxx
请输入私钥:

```
此时输入需要被修改权限人的用户名和私钥，该用户的`owner`权限将被分配给配置文件中的`keys` 和 自己的公钥


### 恢复 active 权限私钥
仅在 `owner` 权限仅有一个公钥的时候可以使用，该操作会将用户的 `active` 权限变更为 `owner` 权限一致。
