let DMC = require('dmc.js');
let config = require("./config.json")

let account = "";
let private_key = "";

console.notice("------- 恢复账户 active 权限工具 -------\n");
while (true) {
    account = console.readLine("请输入用户名:\n");
    if (!account) continue;
    private_key = console.getpass("请输入私钥:\n")
    if (!private_key) continue;
    break;
}

let pubKey = DMC.modules.ecc.privateToPublic(private_key)
//初始化客户端
let dmc = DMC({
    chainId: config.chainId,
    keyProvider: private_key,
    httpEndpoint: config.httpEndpoint,
    logger: {
        log: null,
        error: null
    }
});

let auth = {}
auth.threshold = 1;
auth.keys = [{
    "key": pubKey, "weight": 1
}];


let yes = console.readLine(`\n-------------------------------------\n此方法会将 ${account} 用户的 active 权限变更为 ${pubKey} \n请确认 (Y/N)? \n-------------------------------------\n`)
if (['Y', 'y'].indexOf(yes) !== -1) {
    let ctx = dmc.contractSync('dmc');
    ctx.updateauthSync({
        account: account,
        permission: 'active',
        parent: 'owner',
        auth: auth
    }, {
        authorization: `${account}@owner`
    });
}
console.log("\n执行成功")