let DMC = require('dmc.js');
let config = require("./config.json")

let account = "";
let private_key = "";

console.notice("------- 修改账户 active 权限工具 -------\n");
while (true) {
    account = console.readLine("请输入用户名:\n");
    if (!account) continue;
    private_key = console.getpass("请输入私钥:\n")
    if (!private_key) continue;
    break;
}

//初始化客户端
let dmc = DMC({
    chainId: config.chainId,
    keyProvider: private_key,
    httpEndpoint: config.httpEndpoint,
    logger: {
        log: null,
        error: null
    }
});

let auth = {}
let length = config.accounts.length;
if (length === 0) {
    console.error(`参数错误!`)
    process.exit(1)
}
auth.threshold = length;
auth.accounts = [];

function printArray(array) {
    let res = "";
    console.log("--------- 检查配置信息中 -----------")
    array.forEach(e => {
        let k = {};
        console.log("...")
        try {
            dmc.getAccountSync(e);
        } catch (e) {
            console.error(`${e} 用户不存在，请检查!`)
            process.exit(1)
        }

        res += `${e}\n`
        k.permission = { "actor": e, "permission": "active" }
        k.weight = 1;
        auth.accounts.push(k)
    })

    console.log("--------- 检查完毕 -----------\n")
    return res;
}
let yes = console.readLine(`\n-------------------------------------\n此方法会将 ${account} 用户的 active 权限分配给\n${printArray(config.accounts)}\n 一共 ${length} 个人\n请确认 (Y/N)? \n-------------------------------------\n`)
if (['Y', 'y'].indexOf(yes) !== -1) {
    let ctx = dmc.contractSync('dmc');
    ctx.updateauthSync({
        account: account,
        permission: 'active',
        parent: 'owner',
        auth: auth
    }, {
        authorization: `${account}@owner`
    });
}
console.log("\n执行成功")