let DMC = require('dmc.js');
let config = require("./config.json")

let account = "";
let private_key = "";

console.notice("------- 修改账户 owner 权限工具 -------\n");
while (true) {
    account = console.readLine("请输入用户名:\n");
    if (!account) continue;
    private_key = console.getpass("请输入私钥:\n")
    if (!private_key) continue;
    break;
}

let pubKey = DMC.modules.ecc.privateToPublic(private_key)
//初始化客户端
let dmc = DMC({
    chainId: config.chainId,
    keyProvider: private_key,
    httpEndpoint: config.httpEndpoint,
    logger: {
        log: null,
        error: null
    }
});

let auth = {}
let length = config.keys.length;
if (length === 1) {
    console.error(`参数错误!`)
    process.exit(1)
}
auth.threshold = length;
auth.keys = [];

function printArray(array) {
    let res = `${pubKey}\n`;
    console.log("--------- 检查配置信息中 -----------")
    array.forEach(e => {
        let k = {};
        console.log("...")
        if (!DMC.modules.ecc.isValidPublic(e)) {
            console.error(`${e} 无效公钥，请检查!`)
            process.exit(1)
        }

        res += `${e}\n`
        k = { "key": e, "weight": 1 }
        auth.keys.push(k)
    })
    auth.keys.push({ "key": pubKey, "weight": length })

    console.log("--------- 检查完毕 -----------\n")
    return res;
}

let yes = console.readLine(`\n-------------------------------------\n此方法会将 ${account} 用户的  owner 权限分配给\n${printArray(config.keys)}\n 请确认 (Y/N)? \n-------------------------------------\n`)
if (['Y', 'y'].indexOf(yes) !== -1) {
    let ctx = dmc.contractSync('dmc');
    ctx.updateauthSync({
        account: account,
        permission: 'owner',
        parent: '',
        auth: auth
    }, {
        authorization: `${account}@owner`
    });
}
console.log("\n执行成功")